<template>
  <div>
    <div class="header">
      <SvgIcon size="19" name="list" />
      <div class="title">任务列表</div>
    </div>
    <BasicTable @register="registerTable">
      <template #toolbar>
        <a-button type="primary" @click="handleCreate" :icon="h(PlusOutlined)">新增</a-button>
        <div style="width: 10px" />
        <a-button type="default" @click="handleImport" :icon="h(ImportOutlined)">导入数据</a-button>
        <div style="width: 10px" />
        <a-button type="default" @click="handleDownload" :icon="h(DownloadOutlined)" :disabled="checkedKeys.length === 0">下发数据</a-button>
        <a-button type="default" @click="handleSync" :icon="h(SyncOutlined)" :disabled="checkedKeys.length === 0">同步数据</a-button>
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.dataIndex === 'action'">
          <TableAction
            :actions="[
              {
                label: '编辑',
                icon: 'clarity:note-edit-line',
                onClick: handleEdit.bind(null, record),
                divider: true,
              },
              {
                label: '删除',
                icon: 'ant-design:delete-outlined',
                color: 'error',
                popConfirm: {
                  title: '是否确认删除',
                  confirm: handleDelete.bind(null, record),
                  placement: 'topRight',
                },
                ifShow: hasPermission('AUTH_DATA_TASK:DELETE'),
              },
              {
                label: '详情',
                icon: 'ant-design:eye-outlined',
                onClick: handleView.bind(null, record),
                divider: true
              },
              {
                label: '下发数据',
                icon: 'ant-design:download-outlined',
                onClick: handleDownload.bind(null, record),
                divider: true,
                disabled: record.state !== 0
              },
              {
                label: '同步数据',
                icon: 'ant-design:sync-outlined',
                onClick: handleSync.bind(null, record),
                divider: true,
                disabled: record.state !== 0
              },
            ]"
          />
        </template>
      </template>
    </BasicTable>
    <TaskDrawer @register="registerDrawer" @success="handleSuccess" />
  </div>
</template>
<script lang="ts" setup>
  import { useGo } from '@/hooks/web/usePage';
  import { usePermission } from '@/hooks/web/usePermission';
  import { BasicTable, useTable, TableAction } from '@/components/Table';
  import { isObject } from '@/utils/is';
  import dayjs from 'dayjs';
  import * as TaskApi from '@/api/data/taskApi';
  import { useDrawer } from '@/components/Drawer';
  import TaskDrawer from './drawer.vue';
  import { columns, searchFormSchema } from './schema';
  import { useMessage } from "@/hooks/web/useMessage";
  import {SvgIcon} from "@/components/Icon";
  import {h, ref} from "vue";
  import {
    DownloadOutlined,
    ImportOutlined,
    PlusOutlined,
    SyncOutlined
  } from "@ant-design/icons-vue";
  const { createMessage } = useMessage();
  const { hasPermission } = usePermission();
  const go = useGo();
  const checkedKeys = ref<Array<string | number>>([]);
  const onSelectChange = (selectedRowKeys: (string | number)[]) => {
    checkedKeys.value = selectedRowKeys.filter(k => typeof k !== 'undefined');
  }
  const [registerDrawer, { openDrawer }] = useDrawer();
  const [registerTable, { reload }] = useTable({
    api: (params) => TaskApi.search(handleParams(params)),
    columns,
    formConfig: {
      labelWidth: 0,
      schemas: searchFormSchema,
      showAdvancedButton: false,
    },
    rowSelection: {
      type: 'checkbox',
      onChange: onSelectChange,
      getCheckboxProps: (record) => ({ disabled: record.state !== 0})
    },
    useSearchForm: true,
    showTableSetting: false,
    bordered: true,
    showIndexColumn: false,
    canResize: false,
    rowKey: (record: any) => record.id,
    actionColumn: {
      width: 420,
      title: '操作',
      dataIndex: 'action',
      fixed: undefined,
    },
  });
  const handleParams = (params) => {
    const { pageNum, pageSize, field = 'id', order = 'descend', ...rest } = params;
    const handledParams: any = { pageNum, pageSize, orderByClause: `${field} ${order === 'descend' ? 'desc' : 'asc'}` };
    Object.keys(rest).forEach((key) => {
      const schema = searchFormSchema.find((item) => item.field === key);
      const value = params[key];
      let paramKey = key;
      if (schema) {
        if (value !== undefined && value !== '') {
          if (schema.component === 'Input') {
            handledParams[paramKey] = `%${value.trim()}%`;
          } else if (['Select', 'ApiSelect', 'ApiTreeSelect'].includes(schema.component)) {
            handledParams[paramKey] = isObject(value) ? value.value : value;
          } else if (schema.component === 'RangePicker') {
            if (paramKey === 'startTimeQuery') {
              paramKey = 'startTime';
            }
            handledParams[`${paramKey}From`] = dayjs(value[0]).startOf('d').format('YYYY-MM-DD HH:mm:ss');
            handledParams[`${paramKey}To`] = dayjs(value[1]).endOf('d').format('YYYY-MM-DD HH:mm:ss');
          } else if (schema.component === 'DatePicker') {
            handledParams[paramKey] = dayjs(value).format((schema.componentProps as any).format || 'YYYY-MM-DD');
          } else {
            handledParams[paramKey] = value;
          }
        }
      } else {
        handledParams[paramKey] = value;
      }
    });
    return handledParams;
  };

  const handleCreate = () => {
    openDrawer(true, {
      isUpdate: false,
    });
  };

  const handleEdit = (record: Recordable) => {
    openDrawer(true, {
      record,
      isUpdate: true,
    });
  };

  const handleDelete = (record: Recordable) => {
    TaskApi.remove(record.id).then((_) => {
      reload();
    });
  };

  const handleSuccess = () => {
    reload();
  };

  const handleView = (record) => {
    go('/data/task/' + record.id);
  };

  const handleImport = () => {
    WebViewService.importExcel().then((str) => {
      useMessage().createMessage.success("数据导入成功！");
      const data = JSON.parse(str);
      if (data.length === 0) return;
      const taskName = data[0].name;
      data.forEach(item => {
        delete item.name;
      })
      const record = {
        name: taskName,
        paramJson: JSON.stringify(data),
      };
      // 打开新增
      openDrawer(true, {
        record,
        isUpdate: false,
      });
    }, error => {
      useMessage().createMessage.error(error);
    });
  }

  const handleDownload = (record: Recordable) => {
    const ids = [...new Set([...(record.id ? [record.id] : []), ...(checkedKeys.value.map(d => (d)))])]
    DeviceClientService.assignTasks(ids).then(() => {
      useMessage().createMessage.success("下发任务成功！");
    }, error => {
      useMessage().createMessage.error(error);
    });
  };

  const handleSync = (record: Recordable) => {
    const ids = [...new Set([...(record.id ? [record.id] : []), ...(checkedKeys.value.map(d => (d)))])]
    DeviceClientService.syncTasks(ids).then(() => {
      useMessage().createMessage.success("同步任务成功！");
      reload();
    }, error => {
      useMessage().createMessage.error(error);
    });
  };
</script>
<style lang="scss" scoped>
  @use '@/assets/custom.scss';
</style>
